using System;
using System.Collections.Generic;
using System.IO;
using Gtk;

namespace Amic{
	namespace GridCreator
		{
		public static class Archiver
		{
			public static Stack<string> FileStack;
			public static Gdk.Color background_color {get;set;} // Color de fons per defecte, en format #RRGGBB
			public static string font_color {get;set;}// Color de la font per defecte, en format #RRGGBB
			public static string font_name {get;set;}
			//public static string font_size {get;set;}
			public static int font_size {get;set;}
			public static string font_negreta {get;set;}
			public static string font_italica {get;set;}
			public static string currentStatus;
		
			public static string cadena_font="";
			
			
			public static bool CreateArchive(string Project, string filename_with_ext){
				
				string CompleteFilename=Amic.GridCreator.Preferences.dir_grids+"/"+Project+".AmicProject/";
				Console.WriteLine("SAVING "+CompleteFilename+ " into " +filename_with_ext);
				Console.WriteLine("Project Name: "+ Project);
				
				try{
					if(System.IO.Directory.Exists(CompleteFilename)){
					
						Console.WriteLine("Project has: "+System.IO.Directory.GetFiles(CompleteFilename).Length +"files");
					
					// Creem els directoris temporals...
						if (Directory.Exists("/tmp/lliurex-amic"))
							Directory.Delete("/tmp/lliurex-amic", true); // true -> Eliminat recursiu...
						
						Directory.CreateDirectory("/tmp/lliurex-amic");
						Directory.CreateDirectory("/tmp/lliurex-amic/themes"); // Per guardar els temes...
						Directory.CreateDirectory("/tmp/lliurex-amic/themes/xsd"); // Per guardar els temes...
						Directory.CreateDirectory("/tmp/lliurex-amic/"+Project+".AmicProject"); // Per guardar les galeries...
						Directory.CreateDirectory("/tmp/lliurex-amic/ImageGallery"); // Per guardar les imatges
						Directory.CreateDirectory("/tmp/lliurex-amic/ImageGallery/Default"); // Per guardar les imatges
						Directory.CreateDirectory("/tmp/lliurex-amic/ImageGallery/Custom"); // Per guardar les imatges
						Directory.CreateDirectory("/tmp/lliurex-amic/AudioGallery"); // Per guardar l'audio
						Directory.CreateDirectory("/tmp/lliurex-amic/AudioGallery/Default"); // Per guardar l'audio
						Directory.CreateDirectory("/tmp/lliurex-amic/AudioGallery/Custom"); // Per guardar l'audio
						
						// Copiem el projecte
						foreach (string file in Directory.GetFiles(CompleteFilename)){
							string filename=file.Substring(CompleteFilename.Length, file.Length-CompleteFilename.Length);
							Console.WriteLine("Copying "+file+" to "+"/tmp/lliurex-amic/"+Project+".AmicProject/"+filename);
							
							//Console.WriteLine("11111111111111111");
							File.Copy(file, "/tmp/lliurex-amic/"+Project+".AmicProject/"+filename);							
							//Console.WriteLine("2222222222222222222222222222");
							StreamReader fd=File.OpenText(file);
							string linia;
							while((linia=fd.ReadLine())!=null){
								//Console.WriteLine("33333"+linia);
								// Copiem les imatges del picto
								if (linia.Contains("<source>")){
									string img=linia.Replace("<source>","").Replace("</source>","").TrimEnd(new Char[] {' '}).TrimStart(new Char[] {' '});
									//Console.WriteLine("4444444"+img.ToString());
									//if(img.IndexOf("/")==-1) CreateDirs(img, "/tmp/lliurex-amic/ImageGallery"); // Creem tots els subdirectoris que apareixen a la línia a partir del path
									// TODO: Solventar el bug... quan no hi ha imatge al picto, casca en la següent línia
									CreateDirs(img, "/tmp/lliurex-amic/ImageGallery"); // Creem tots els subdirectoris que apareixen a la línia a partir del path
									///Console.WriteLine("555"+img.ToString());   
									Console.WriteLine("File: "+img);
									if (File.Exists(GridCreator.Preferences.dir_img+"/"+img)){
										Console.WriteLine("Copying file"+ GridCreator.Preferences.dir_img+"/"+img);
										if (!File.Exists("/tmp/lliurex-amic/ImageGallery/"+img))
											File.Copy(GridCreator.Preferences.dir_img+"/"+img, "/tmp/lliurex-amic/ImageGallery/"+img);
										
									}
 								
								}
								
								// Copiem l'audio del picto
								
								if (linia.Contains("<sound>")){
									string snd=linia.Replace("<sound>","").Replace("</sound>","").TrimEnd(new Char[] {' '}).TrimStart(new Char[] {' '});

									CreateDirs(snd, "/tmp/lliurex-amic/AudioGallery"); // Creem tots els subdirectoris que apareixen a la línia a partir del path

									Console.WriteLine("File: "+snd);
									if (File.Exists(GridCreator.Preferences.dir_audio+"/"+snd)){
										Console.WriteLine("Copying file"+ GridCreator.Preferences.dir_audio+"/"+snd);
										if (!File.Exists( "/tmp/lliurex-amic/AudioGallery/"+snd))
											File.Copy(GridCreator.Preferences.dir_audio+"/"+snd, "/tmp/lliurex-amic/AudioGallery/"+snd);
									}
 								
								}
								
								
							} // While
						
							
							
						} // foreach
						
						
						// Finalment, comprimim l'arxiu
	
						System.IO.Directory.SetCurrentDirectory("/tmp/");
						Stream stmout=new FileStream(filename_with_ext, FileMode.Create);
						ICSharpCode.SharpZipLib.Tar.TarArchive TA=ICSharpCode.SharpZipLib.Tar.TarArchive.CreateOutputTarArchive(stmout);
						ICSharpCode.SharpZipLib.Tar.TarEntry TE=ICSharpCode.SharpZipLib.Tar.TarEntry.CreateEntryFromFile("lliurex-amic/");
						TA.WriteEntry(TE,true);
						TA.CloseArchive();
						stmout.Close();
						
					
					}	
					
				} catch (Exception exc){
					Console.WriteLine("Exception Saving... "+exc);
						return false;
					}
				return true;
			}
			
			public static void CreateDirs(string linia, string path) // Creem tots els subdirectoris que apareixen a la línia a partir del path
			{
				Console.WriteLine("LINIA:"+linia);
				
				if(linia.IndexOf("/")>0)
					linia=linia.Substring(0,linia.LastIndexOf("/")); // Eliminem el nom de l'arxiu
				Console.WriteLine("Creating subdirs for path: "+linia);
				
				string [] dirs=linia.Split(new Char[] {'/'});
				string CompletePath=path;
				
				foreach(string dir in dirs){
					CompletePath=CompletePath+"/"+dir;
					if(!Directory.Exists(CompletePath)){
						// Si no existeix el directori, el creem
						Directory.CreateDirectory(CompletePath);
						Console.WriteLine("Created path: "+CompletePath);
					}
				}				
			}
			
			
			public static bool ImportArchive(string filename){
				
				Console.WriteLine("Archive: "+filename);
				
				// Descomprimim en tmp
				
				try{
					// Creem els directoris temporals...
					if (Directory.Exists("/tmp/lliurex-amic"))
						Directory.Delete("/tmp/lliurex-amic", true); // true -> Eliminat recursiu...
					
					Directory.CreateDirectory("/tmp/lliurex-amic");
					
					Stream stmin=new FileStream(filename, FileMode.Open);
					ICSharpCode.SharpZipLib.Tar.TarArchive TA;
					TA=ICSharpCode.SharpZipLib.Tar.TarArchive.CreateInputTarArchive(stmin);
					//TA.SetAsciiTranslation(true);
					TA.ExtractContents("/tmp");
					TA.CloseArchive();
					stmin.Close();
					
					// I anem copiant cada cosa on toca...
					
					string []files=Directory.GetDirectories("/tmp/lliurex-amic/","*.AmicProject");
					string Project=(files[0]).Replace(".AmicProject", "").Replace("/tmp/lliurex-amic/","");
					Console.WriteLine("Project Name: "+Project);
					
					string ProjectFullName=GridCreator.Preferences.dir_grids+"/"+Project+".AmicProject";
					string OriginFullName=files[0];
					
					Console.WriteLine("Creating Project "+ProjectFullName);
					
					if(Directory.Exists(ProjectFullName)){
						int num=0;
						do{
							ProjectFullName=GridCreator.Preferences.dir_grids+"/"+Project+"-"+num+".AmicProject";
							num++;
						} while(Directory.Exists(ProjectFullName));
						
						MessageDialog md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
				      	                       		MessageType.Question, ButtonsType.Close,
				          	                   		Mono.Unix.Catalog.GetString("The project ")+ Project+Mono.Unix.Catalog.GetString(" already exists.\n\n It will be named "+Project+"-"+(num-1)+"."));
						md.Run();				
						md.Destroy();
												
					}
					
					Directory.CreateDirectory(ProjectFullName);
					
					Console.WriteLine("OriginalFullName: "+OriginFullName);
					Console.WriteLine("Té: "+Directory.GetFiles(OriginFullName).Length);					
					
					foreach(string file in Directory.GetFiles(OriginFullName)){
						string gridname=file.Substring(file.LastIndexOf("/")+1, file.Length-file.LastIndexOf("/")-1);
						
						Console.WriteLine("Importing file... "+file+" to *"+ProjectFullName+"/"+gridname+"*");
						if(!File.Exists(ProjectFullName+"/"+gridname))
							File.Copy(file, ProjectFullName+"/"+gridname);
					}
					
					// I ara copiem les imatges *************************
					
					// 1. Imatges personalitzades
					
					List <string> imagePaths=new List<string>();
					imagePaths.Add("ImageGallery/Custom");
					
					while(imagePaths.Count>0){
						string imagePath=imagePaths[0]; // Assignem el primer element
						string fileToCopy="";
						string img_filename="";
						foreach(string file in Directory.GetFiles("/tmp/lliurex-amic/"+imagePath)){
							Console.WriteLine("FiLe:*"+file+"*");
							//img_filename=file.Substring(file.LastIndexOf("/")+1, file.Length-file.LastIndexOf("/")-1);
							//img_filename=file.Replace(GridCreator.Preferences.dir_img+"/Custom","");
							img_filename=file.Replace("/tmp/lliurex-amic/ImageGallery/Custom","");
							Console.WriteLine("img_filename: "+img_filename);
							//.Substring(file.LastIndexOf("/")+1, file.Length-file.LastIndexOf("/")-1);
							fileToCopy=GridCreator.Preferences.dir_img+"/Custom"+img_filename;
							Console.WriteLine("Copied to: "+fileToCopy);
							// I fem la còpia...
							if (File.Exists(fileToCopy)) 
							{
								
								MessageDialog md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
				      	                              		MessageType.Question, ButtonsType.YesNo, 
				          	                          		Mono.Unix.Catalog.GetString("File ")+img_filename+Mono.Unix.Catalog.GetString(" already exists. Overwrite it?"));
								ResponseType result = (ResponseType)md.Run();
				
								md.Destroy();
		
								if (result==ResponseType.Yes){ // Si diu que si l'eliminem i la tornem a copiar
									File.Delete(fileToCopy);
									File.Copy(file, fileToCopy);
								}
							} else File.Copy(file, fileToCopy); // Si no existeix, el creem
							
								
						}
						
						imagePaths.Remove(imagePath);
						
						foreach(string file in Directory.GetDirectories("/tmp/lliurex-amic/"+imagePath)){
							Console.WriteLine("DIR tmp: "+file);
							Console.WriteLine("DIR dst: "+file.Replace("/tmp/lliurex-amic/ImageGallery",GridCreator.Preferences.dir_img));
							Directory.CreateDirectory(file.Replace("/tmp/lliurex-amic/ImageGallery",GridCreator.Preferences.dir_img));
							imagePaths.Add(file.Replace("/tmp/lliurex-amic/",""));
							//imagePaths.Add(imagePath
						}
						
					}
					
					// 2. Imatges per defecte
					
					Console.WriteLine();Console.WriteLine();
					Console.WriteLine("DEFAULT IMAGES");
					Console.WriteLine();Console.WriteLine();
					
					imagePaths.Clear();
					imagePaths.Add("ImageGallery/Default");
					
					while(imagePaths.Count>0){
						string imagePath=imagePaths[0]; // Assignem el primer element
						string fileToCopy="";
						string img_filename="";
						foreach(string file in Directory.GetFiles("/tmp/lliurex-amic/"+imagePath)){
							Console.WriteLine("FiLe:*"+file+"*");
						
							img_filename=file.Replace("/tmp/lliurex-amic/ImageGallery/Default","");
							Console.WriteLine("img_filename: "+img_filename);
						
							fileToCopy=GridCreator.Preferences.dir_img+"/Default"+img_filename;
							Console.WriteLine("Copied to: "+fileToCopy);
							// I fem la còpia...
							if (!File.Exists(fileToCopy)) 
							{
								
								string _filename=fileToCopy.Replace(GridCreator.Preferences.dir_img+"/Default","");
								MessageDialog md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
		      	                              		MessageType.Question, ButtonsType.YesNo, 
		          	                          		Mono.Unix.Catalog.GetString("File ")+ 
				                                      _filename +Mono.Unix.Catalog.GetString(" does not exists in your Default Gallery.\n\n"+
								                            " It seems that you don't have installed any Image Packages. \n\n" +
		          	                          				"Do you want to import this image to your Custom Image Gallery?"));

								ResponseType result = (ResponseType)md.Run();
				
								md.Destroy();
								
								if (result==ResponseType.Yes){ 
								// Si respon que si, cal crear els paths i modificar l'arxiu del grid!
									Console.WriteLine();
									string MyPath=fileToCopy.Replace(GridCreator.Preferences.dir_img+"/Default", "Custom");
									Console.WriteLine("Cal crear... "+MyPath);
									CreateDirs(MyPath, GridCreator.Preferences.dir_img); //
									
									Console.WriteLine("Copie... *"+file+"* a *"+GridCreator.Preferences.dir_img+"/"+MyPath+"*");
									
									if(File.Exists(GridCreator.Preferences.dir_img+"/"+MyPath)){
										md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
				      	                              		MessageType.Question, ButtonsType.YesNo, 
				          	                          		Mono.Unix.Catalog.GetString("File ")+MyPath+Mono.Unix.Catalog.GetString(" already exists. Overwrite it?"));
										result = (ResponseType)md.Run();
				
										md.Destroy();
		
										if (result==ResponseType.Yes){ // Si diu que si l'eliminem i la tornem a copiar
											File.Delete( GridCreator.Preferences.dir_img+"/"+MyPath);
											File.Copy(file,  GridCreator.Preferences.dir_img+"/"+MyPath);
										} // Si diu que no, no fem res...
										
									}
									else File.Copy(file, GridCreator.Preferences.dir_img+"/"+MyPath); //
									
									
									string MyFileDefault="<source>"+fileToCopy.Replace(GridCreator.Preferences.dir_img+"/", "")+"</source>";
									string MyFileCustom="<source>"+MyPath+"</source>";
									
									Console.WriteLine("Modificant:"+MyFileDefault);
									Console.WriteLine("per:"+MyFileCustom);
									
									Console.WriteLine("Al directori: "+ProjectFullName);
									
									// Modificació dels arxius
									ReplaceTextInDir(MyFileDefault, MyFileCustom, ProjectFullName);
									
									Console.WriteLine();
								}
								
								} // IF file exist
							
						}
						
						imagePaths.Remove(imagePath);
						
						foreach(string file in Directory.GetDirectories("/tmp/lliurex-amic/"+imagePath)){
							Console.WriteLine("DIR tmp: "+file);
							Console.WriteLine("DIR dst: "+file.Replace("/tmp/lliurex-amic/ImageGallery",GridCreator.Preferences.dir_img));
							
							imagePaths.Add(file.Replace("/tmp/lliurex-amic/",""));
							
						}
						
					}
					
					
					
					
					
					
					// I l'audio ************************************
					
					
					// 1. sons personalitzats
					
					List <string> audioPaths=new List<string>();
					audioPaths.Add("AudioGallery/Custom");
					
					while(audioPaths.Count>0){
						string audioPath=audioPaths[0]; // Assignem el primer element
						string fileToCopy="";
						string audio_filename="";
						foreach(string file in Directory.GetFiles("/tmp/lliurex-amic/"+audioPath)){
							Console.WriteLine("FiLe:*"+file+"*");
							
							audio_filename=file.Replace("/tmp/lliurex-amic/AudioGallery/Custom","");
							Console.WriteLine("audio_filename: "+audio_filename);
							
							fileToCopy=GridCreator.Preferences.dir_audio+"/Custom"+audio_filename;
							Console.WriteLine("Copied to: "+fileToCopy);
							
							// I fem la còpia...
							if (File.Exists(fileToCopy)) 
							{
								
								MessageDialog md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
				      	                              		MessageType.Question, ButtonsType.YesNo, 
				          	                          		Mono.Unix.Catalog.GetString("File ")+audio_filename+Mono.Unix.Catalog.GetString(" already exists. Overwrite it?"));
								ResponseType result = (ResponseType)md.Run();
				
								md.Destroy();
		
								if (result==ResponseType.Yes){ // Si diu que si l'eliminem i la tornem a copiar
									File.Delete(fileToCopy);
									File.Copy(file, fileToCopy);
								}
							} else File.Copy(file, fileToCopy); // Si no existeix, el creem
							
								
						}
						
						audioPaths.Remove(audioPath);
						
						foreach(string file in Directory.GetDirectories("/tmp/lliurex-amic/"+audioPath)){
							Console.WriteLine("DIR tmp: "+file);
							Console.WriteLine("DIR dst: "+file.Replace("/tmp/lliurex-amic/AudioGallery",GridCreator.Preferences.dir_audio));
							Directory.CreateDirectory(file.Replace("/tmp/lliurex-amic/AudioGallery",GridCreator.Preferences.dir_audio));
							audioPaths.Add(file.Replace("/tmp/lliurex-amic/",""));
							//audioPaths.Add(audioPath
						}
						
					}
					
					// 2. Sons per defecte
					
					Console.WriteLine();Console.WriteLine();
					Console.WriteLine("DEFAULT SOUNDS");
					Console.WriteLine();Console.WriteLine();
					
					audioPaths.Clear();
					audioPaths.Add("AudioGallery/Default");
					
					while(audioPaths.Count>0){
						string audioPath=audioPaths[0]; // Assignem el primer element
						string fileToCopy="";
						string audio_filename="";
						foreach(string file in Directory.GetFiles("/tmp/lliurex-amic/"+audioPath)){
							Console.WriteLine("FiLe:*"+file+"*");
						
							audio_filename=file.Replace("/tmp/lliurex-amic/AudioGallery/Default","");
							Console.WriteLine("audio_filename: "+audio_filename);
						
							fileToCopy=GridCreator.Preferences.dir_audio+"/Default"+audio_filename;
							Console.WriteLine("Copied to: "+fileToCopy);
							// I fem la còpia...
							if (!File.Exists(fileToCopy)) 
							{
								
								string _filename=fileToCopy.Replace(GridCreator.Preferences.dir_audio+"/Default","");
								MessageDialog md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
		      	                              		MessageType.Question, ButtonsType.YesNo, 
		          	                          		Mono.Unix.Catalog.GetString("File ")+ 
				                                      _filename +Mono.Unix.Catalog.GetString(" does not exists in your Default Gallery.\n\n"+
								                            " It seems that you don't have installed any Amic Gallery Packages. \n\n" +
		          	                          				"Do you want to import this image to your Custom Audio Gallery?"));

								ResponseType result = (ResponseType)md.Run();
				
								md.Destroy();
								
								if (result==ResponseType.Yes){ 
								// Si respon que si, cal crear els paths i modificar l'arxiu del grid!
									Console.WriteLine();
									string MyPath=fileToCopy.Replace(GridCreator.Preferences.dir_audio+"/Default", "Custom");
									Console.WriteLine("Cal crear... "+MyPath);
									CreateDirs(MyPath, GridCreator.Preferences.dir_audio); //
									
									Console.WriteLine("Copie... *"+file+"* a *"+GridCreator.Preferences.dir_audio+"/"+MyPath+"*");
									
									if(File.Exists(GridCreator.Preferences.dir_audio+"/"+MyPath)){
										md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
				      	                              		MessageType.Question, ButtonsType.YesNo, 
				          	                          		Mono.Unix.Catalog.GetString("File ")+MyPath+Mono.Unix.Catalog.GetString(" already exists. Overwrite it?"));
										result = (ResponseType)md.Run();
				
										md.Destroy();
		
										if (result==ResponseType.Yes){ // Si diu que si l'eliminem i la tornem a copiar
											File.Delete( GridCreator.Preferences.dir_audio+"/"+MyPath);
											File.Copy(file,  GridCreator.Preferences.dir_audio+"/"+MyPath);
										} // Si diu que no, no fem res...
										
									}
									else File.Copy(file, GridCreator.Preferences.dir_audio+"/"+MyPath); //
									
									
									string MyFileDefault="<sound>"+fileToCopy.Replace(GridCreator.Preferences.dir_audio+"/", "")+"</sound>";
									string MyFileCustom="<sound>"+MyPath+"</sound>";
									
									Console.WriteLine("Modificant:"+MyFileDefault);
									Console.WriteLine("per:"+MyFileCustom);
									
									Console.WriteLine("Al directori: "+ProjectFullName);
									
									// Modificació dels arxius
									ReplaceTextInDir(MyFileDefault, MyFileCustom, ProjectFullName);
									
									Console.WriteLine();
								}
								
								} // IF file exist
							
						}
						
						audioPaths.Remove(audioPath);
						
						foreach(string file in Directory.GetDirectories("/tmp/lliurex-amic/"+audioPath)){
							Console.WriteLine("DIR tmp: "+file);
							Console.WriteLine("DIR dst: "+file.Replace("/tmp/lliurex-amic/AudioGallery",GridCreator.Preferences.dir_audio));
							
							audioPaths.Add(file.Replace("/tmp/lliurex-amic/",""));
							
						}
						
					}
					
					
					
					
					
					
					
					
		
				} catch(Exception exc){
					Console.WriteLine("Import exception: "+exc.Message);
					return false;
				}		
				
				return true;
			}
			
			static public void ReplaceTextInDir(string Default, string Custom, string ProjectFullName){
				foreach(string file in Directory.GetFiles(ProjectFullName, "*.grid")){
					Console.WriteLine("Obric: "+file);
					
					if(File.Exists("/tmp/amic-grid-tmp.grid")) File.Delete("/tmp/amic-grid-tmp.grid");
					File.Move(file, "/tmp/amic-grid-tmp.grid");
					
					StreamReader fd=File.OpenText("/tmp/amic-grid-tmp.grid");
					StreamWriter sr=File.CreateText(file);
					string linia;
					
					while((linia=fd.ReadLine())!=null){
								linia=linia.Replace(Default, Custom);
								sr.WriteLine(linia);
								
					}
					sr.Close();
					fd.Close();
				}
			
			} // Function ReplaceTextInDir
				
			public static bool ImportFromPla(string filename, string projectName, string status, List<string> importedGrids){
				// Import filename into projectName
				// status: "first": Firts Call
				// status: "recursive": Imports recursively
				// status: "none": Don't import recursively
				currentStatus=status;
				try{
					Console.WriteLine("filename: "+filename);
					GridCreator.Grid MyGrid=new Amic.GridCreator.Grid();
					importedGrids.Add(filename);// Afegim l'actual filename a la llista d'importats
					MyGrid=ConvertPla2Grid(filename, "Default", projectName, importedGrids);
					Console.WriteLine("CONVERISON FINISHED");
					
					Console.WriteLine(Preferences.dir_grids);
					Console.WriteLine(GeneralUtils.GoodEncode(projectName));
					Console.WriteLine(GeneralUtils.GoodEncode(MyGrid.name));
					
					string FileToSave=Preferences.dir_grids+"/"+GeneralUtils.GoodEncode(projectName)+".AmicProject/"+GeneralUtils.GoodEncode(MyGrid.name)+".grid";
					
					Console.WriteLine("File to save:"+FileToSave);
					Amic.GridCreator.Core.getCore().xmlman.saveFile(FileToSave, MyGrid);
	
					return true;
				}catch(Exception exc){
					Console.WriteLine("Exception in: "+exc.Message);
					return false;
				}
			}
			
			
			
			public static GridCreator.Grid ConvertPla2Grid(string filename, string theme, string projectName, List<string> importedGrids){
			// Extraiem de l'arxiu filename, el grid MyGrid, aplicant el tema theme!
			
				GridCreator.Grid MyGrid=new GridCreator.Grid();
				StreamReader sr=new StreamReader(filename, System.Text.Encoding.GetEncoding("ISO-8859-1"));
				string linia="";
				
				// Capturem el camí cap al grid
				string GridSource=filename.Substring(0,filename.LastIndexOf("/")+1); 
				
				MyGrid.name=GeneralUtils.GoodEncode(filename.Replace(GridSource, "").Replace(".pla",""));
			
				linia=sr.ReadLine();
			
				int fila=1;
				int columna=1;
				//Console.WriteLine("11111111111111111111111");
				while(linia!=null)
				{
					string [] linecontent = linia.Split(new Char [] {'='});				
					if (linecontent.Length==2){
						// Atributs generals
						switch(linecontent[0].Trim()){
						case  "COLUMNES":
							MyGrid.width=int.Parse(linecontent[1]);
							
							break;
						case "FILES":
							MyGrid.height=int.Parse(linecontent[1]);
	
							break;
						case "COLOR": // el posarem com a valor per defecte...
							LectorPla.background_color=ConvertToRGB(linecontent[1]);
							break;
							
						case "CAPTION CENTRAT":
							break;
						case "Font Charset":
							break;
						case "Font Color": 					
							LectorPla.font_color=linecontent[1];						
							break;
						case "Font Height":
							break;
						case "Font Name":
							LectorPla.font_name=linecontent[1];						
							break;
						case "Font Size":
							LectorPla.font_size=int.Parse(linecontent[1]);
							break;
						case "Font Negreta":		
							if(linecontent[1]=="NO") LectorPla.font_negreta="";
								else LectorPla.font_negreta="Bold";						
							break;
						case "Font Itàlica":					
							if(linecontent[1]=="NO") LectorPla.font_italica="";
								else LectorPla.font_italica="Italic";
							break;
						case "Font Subrratllat":
							break;
						case "Font Tatxat":
							break;
						case "BARRA BOTONS":
							break;
						case "BARRA MISSATGE":
							break;
						case "WORDWRAP":
							break;
						case "NÒMES LLETRES":
							break;
						case "ENVIAR FINESTRA EXTERNA":
							break;
						case "POSICIÓ LEFT":
							break;
						case "POSICIÓ WIDTH":
							break;
						case "POSICIÓ TOP":
							break;
	
						case "POSICIÓ HEIGHT":
							break;
								
						}
					
					} else if (linecontent.Length>2){

						
						//Console.WriteLine("aaaaaaaaaaaaaaaaaaaaaaaaaaaaa");

						Console.WriteLine("CADENA: **"+linia+"**");
						Console.WriteLine("cadena_font: **"+ cadena_font+"**");
						Console.WriteLine("font_name: "+LectorPla.font_name);
						Console.WriteLine("font_negreta: "+LectorPla.font_negreta);
						Console.WriteLine("font_italica: "+LectorPla.font_italica);
						Console.WriteLine("font_size: "+LectorPla.font_size);
						
						
						if(cadena_font=="") 
						cadena_font=LectorPla.font_name.Trim()+" "+LectorPla.font_negreta+" "+LectorPla.font_italica
								+" "+LectorPla.font_size.ToString();
					//Console.WriteLine("bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb");
						// Creem el nou pictograma per al grid
						////PictogramInGrid newPic=new PictogramInGrid();
						
						Amic.GridCreator.Pictogram newPic=new Amic.GridCreator.Pictogram();
					
						Console.WriteLine("Parsing line: "+linia);
						Console.WriteLine("with theme: "+theme);
						// Parsejem les línies (1 linia=1 pictograma)
						newPic=ParsePictogram(linia, theme, GridSource, projectName, importedGrids);
						Console.WriteLine("cccccccccccccccccccccccccccccc");
						// Assignem els valors per defecte
						newPic.background=TansformColor(background_color.ToString());
						
						// I afegim el pictograma al grid
						Console.WriteLine("ddddddddddddddddddddddddddddddddddddd");
						newPic.col=columna;
						newPic.row=fila;
						MyGrid.pictogram_list.Add(newPic);
						columna++;
						Console.WriteLine("fffffffffffffffffffffffffffffff");
						
						if(columna>MyGrid.width){
							columna=1;
							fila++;
						}
					}
					
					linia=sr.ReadLine();
			 	
				}
				
				return MyGrid;
									
			}
				
				
				
		
			public static Pictogram ParsePictogram(string linea, string theme, string gridSource, string projectName, List<string> importedGrids){
				
				Amic.GridCreator.Pictogram MyPictogram=new Amic.GridCreator.Pictogram();
				//PictImage MyPict=new PictImage();
			
				//Console.WriteLine("1111111111111111111111111111111111111");
				
				// Agafem la imatge, i la copiem a la galeria personal
			  	string source=GetElementFromString(linea, "PICTURE");
				Console.WriteLine("GridSource:"+gridSource);
				Console.WriteLine("source:"+source);
				Console.WriteLine("projectName:"+projectName);
				
				Console.WriteLine("Copy: "+gridSource+source);
				Console.WriteLine("To: "+Preferences.dir_img+"/Custom/"+projectName+"/"+GeneralUtils.GoodEncode(source));
				
			
				MyPictogram.image_list[theme]=""; // La deixem a nul per defecte
				
				if (File.Exists(gridSource+source)){ // Existeix la ruta
					if(!File.Exists(Preferences.dir_img+"/Custom/"+projectName+"/"+GeneralUtils.GoodEncode(source)))
					{	// Si no existeix, ho copiem
						// Comprovem primer que estiga el directori...
						if(!Directory.Exists(Preferences.dir_img+"/Custom/"+projectName))
						   Directory.CreateDirectory(Preferences.dir_img+"/Custom/"+projectName);
						File.Copy(gridSource+source, Preferences.dir_img+"/Custom/"+projectName+"/"+GeneralUtils.GoodEncode(source));
						
					} // Si l'arxiu ja existeix, no cal que el copiem... (caldria comprovar que siga el mateix...)
					
					// Si al final, tenim l'arxiu on toca, el posem al grid
					if(File.Exists(Preferences.dir_img+"/Custom/"+projectName+"/"+GeneralUtils.GoodEncode(source)))
						MyPictogram.image_list[theme]="Custom/"+projectName+"/"+GeneralUtils.GoodEncode(source);

				} // Si no existeix el font, no podem fer res...
				
				                
				// FI, del PICTURE
				
				                
				string caption=GetElementFromString(linea, "CAPTION");
				MyPictogram.caption=caption;
				MyPictogram.pictname=GeneralUtils.GoodEncode(caption); // Com a identificador, posem el caption
			
				// Per defecte deixem l'acció speech amb el del caption
				MyPictogram.actionSpeech=caption;
				MyPictogram.actionType="speech";
				
				// Si té audio, el posem
				string readedSound;
				readedSound=GetElementFromString(linea, "READ");
				Console.WriteLine("Comprovant si existeix:"+gridSource+readedSound);
				if(readedSound!=""&&File.Exists(gridSource+readedSound)){
					// L'arxiu exsisteix, el posem coma sound
					Console.WriteLine(gridSource+readedSound+" existeix");
					
					try{
						if (!Directory.Exists(Amic.GridCreator.Preferences.dir_audio+"/Custom/"+projectName))
							Directory.CreateDirectory(Amic.GridCreator.Preferences.dir_audio+"/Custom/"+projectName);
						File.Copy(gridSource+readedSound, Amic.GridCreator.Preferences.dir_audio+"/Custom/"+projectName+"/"+Amic.GridCreator.GeneralUtils.GoodEncode(readedSound));
						MyPictogram.actionSound="Custom/"+projectName+"/"+Amic.GridCreator.GeneralUtils.GoodEncode(readedSound);
						MyPictogram.actionType="sound";
					} catch (Exception ex){
						// Si passa alguna excepció, ho deixem com a text a llegir
						Console.WriteLine("Exception impoting audio: "+ex.Message);
						MyPictogram.actionSound="";
						MyPictogram.actionSpeech=readedSound;
						MyPictogram.actionType="speech";
						
					}
					//if (MyPictogram.actionSound!="") MyPictogram.actionType="sound";
				} else {
					// L'arxiu no existeix, s'interpreta com un "READ"
					Console.WriteLine(gridSource+readedSound+" NOOOOOOOOOOO existeix");
					MyPictogram.actionSound="";
					MyPictogram.actionSpeech=readedSound;
					MyPictogram.actionType="speech";
				}
				
				               
				
				
				
				
				// CAL COMPROVAR QUE EL LINK EXISTISCA I ENLLAÇAR-LO!!!!!!!!!!!!!!
				string ReadLink=GetElementFromString(linea, "LINK"); // COntindrà el .pla
				if (ReadLink!="") MyPictogram.actionChild=projectName+"/"+ReadLink.Replace(".pla", "");
				// Mirem si cal importar els fills
				if(MyPictogram.actionChild!=""){
					MyPictogram.actionType="child";
					Console.WriteLine("ACTIONChild TO"+gridSource+MyPictogram.actionChild);
					Console.WriteLine("PROJEKT...."+projectName);
					
					if(currentStatus=="recursive"&&File.Exists(gridSource+ReadLink)
					   &&(!importedGrids.Contains(gridSource+ReadLink)) ){
						Console.WriteLine("*** Is RECURSIVE: "+gridSource+MyPictogram.actionChild);
						ImportFromPla(gridSource+ReadLink, projectName, "recursive", importedGrids);
						
					} else if (currentStatus=="first"){
						Console.WriteLine("*** Is FIRST: "+gridSource+MyPictogram.actionChild);
						MessageDialog md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
						                                      MessageType.Question, ButtonsType.YesNo, 
						                                      Mono.Unix.Catalog.GetString("Plaphoons grid links to another grids, do you want to import all them?"));
						ResponseType result = (ResponseType)md.Run();
						
						md.Destroy();
						
						if (result==ResponseType.Yes){ // Si diu que si l'eliminem i la tornem a copiar
							currentStatus="recursive";
							Console.WriteLine("*** SET RECURSIVE: "+gridSource+MyPictogram.actionChild);
							if(!importedGrids.Contains(gridSource+MyPictogram.actionChild))
								ImportFromPla(gridSource+ReadLink, projectName, "recursive", importedGrids);
						} else currentStatus="none";
					}
					
				}
				
				
				
				
				
				
				
				
				
				MyPictogram.fontColor=TansformColor(ConvertToRGB(GetElementFromString(linea, "FCOLOR")).ToString());
				
				MyPictogram.fontFace=GetElementFromString(linea, "FNAME");
				MyPictogram.fontSize=int.Parse(GetElementFromString(linea, "FSIZE"));
				
				Console.WriteLine("3333333333333333333333333333333333333333333");
				
				string font_bold;
				if(GetElementFromString(linea, "FNEGRETA")!="NO")
					font_bold="Bold";
				else font_bold="";
			
				string font_italic;
				if(GetElementFromString(linea, "FITALICA")!="NO")
					font_italic="Italic";
				else font_italic="";
				
				MyPictogram.fontTypeFace=(font_bold+" "+font_italic).Trim();
				MyPictogram.align="bottom";
			
				return MyPictogram;
			
			}
		
			
			public static string GetElementFromString(string linea, string item){
				// Primera passada: Busquem l'ítem que ens passen
				int i,j;
				i=0; j=0;
				bool trobat=false;
				while(i<linea.Length&&!trobat){
					j=0;
					while ((j<item.Length)&&item[j]==linea[i]){
						i++; j++;
					}
					if (j>=item.Length) trobat=true;
					i++;
				}
				if (trobat){
					//Console.WriteLine(linea.Substring(i+1).IndexOf("\""));
					return linea.Substring(i+1,linea.Substring(i+1).IndexOf("\""));
				}
				return "";
			}
	
			
			public static Gdk.Color ConvertToRGB(string color){
				
				int colorHex=int.Parse(color);
			
			
				byte R=byte.Parse((colorHex&0x0000FF).ToString());
				byte G=byte.Parse(((colorHex&0x00FF00)>>8).ToString());
				byte B=byte.Parse(((colorHex&0xFF0000)>>16).ToString());
				
				//Console.WriteLine("("+R+","+G+","+B+")");
				
				Gdk.Color RetColor=new Gdk.Color(R,G,B);
			
				return RetColor;
			}
		
		
			
			public static string TansformColor(string gtkcolor){
			/*
		 	* Torna un string tipus #rrggbb a partir d'un gtkcolor
		 	* 
		 	* */
				
				string [] color = gtkcolor.Split(new Char [] {':'});
				if (color.Length<1) return "#000000";
				else{
					string [] components=color[1].Split(new Char [] {'/'});
					if (components.Length!=3) return  "#000000";
					else{
						string r,g,b;
						if (components[0].Length>2) r=components[0].Substring(0,2);
						else r="0"+components[0].Substring(0,1);
						
						if (components[1].Length>2) g=components[1].Substring(0,2);
						else g="0"+components[1].Substring(0,1);
						
						if (components[2].Length>2) b=components[2].Substring(0,2);
						else b="0"+components[2].Substring(0,1);
						
						return "#"+r+g+b;
					}
						
				}
				
			
			}
			
			
		}
	}
	
	// Classe LectorPla
	static class LectorPla
	{				
		//public static string background_color {get;set;} // Color de fons per defecte, en format #RRGGBB
		public static Gdk.Color background_color {get;set;} // Color de fons per defecte, en format #RRGGBB
		public static string font_color {get;set;}// Color de la font per defecte, en format #RRGGBB
		public static string font_name {get;set;}
		//public static string font_size {get;set;}
		public static int font_size {get;set;}
		public static string font_negreta {get;set;}
		public static string font_italica {get;set;}
		
		public static string cadena_font="";
	};
	
	
}	


