using System;
using Gtk;


namespace Amic
{

	namespace GridCreator
	{
		public partial class MainWindow : Gtk.Window
		{
			
			
			public Gtk.ListStore store;
			public string GlobalSelectedProject=""; // Per saber el projecte actual
			
			public Gtk.Widget getGridWidget(){
				// Retorna una referència a l'espai on es mostren els grids
				// per tal de poder saber el tamany.
				return this.GtkScrolledWindow;
				//return this.vbox_grid;
			}
			
			public MainWindow () : base(Gtk.WindowType.Toplevel)
			{
				Build ();
				//Amic.GridCreator.Core core =Amic.GridCreator.Core.getCore();
				/*
				Gtk.Button button=new Gtk.Button();
				button.Label="tralari";
				button.Show();
				
				Amic.GridCreator.Core.getCore().current=button;
				vbox2.Add(Amic.GridCreator.Core.getCore().current);
				*/

				store=new ListStore(typeof(string));				
				//themeCombobox.Sensitive=false;
				themeCombobox.Model=store;
				
				
				/*******************************************************/
				/* Gestió de les finestres laterals de projecte i grids
			    /*******************************************************/
				
				
				// Definició de la Finestra de projectes
				
				TreeViewColumn colIcon=new TreeViewColumn("", new Gtk.CellRendererPixbuf (), "pixbuf", 0);
				//colIcon.Clickable=true;
				ProjectsTreeView.AppendColumn(colIcon);
				TreeViewColumn colFile=new TreeViewColumn("Project", new Gtk.CellRendererText (), "text", 1);
				//colFile.Clickable=true;
				ProjectsTreeView.AppendColumn(colFile);

				// Omplim la finestra de projectes
				LoadProjects();
				
				// Definició de la Finestra de grids				
				
				
				colIcon=new TreeViewColumn("", new Gtk.CellRendererPixbuf (), "pixbuf", 0);
				//colIcon.Clickable=true;
				GridsTreeView.AppendColumn(colIcon);
				colFile=new TreeViewColumn("Grid", new Gtk.CellRendererText (), "text", 1);
				//colFile.Clickable=true;
				GridsTreeView.AppendColumn(colFile);
				
				
				// Gestió d'events
				
				ProjectsTreeView.Selection.Changed += HandleProjectsTreeViewSelectionChanged;
				GridsTreeView.Selection.Changed += HandleGridsTreeViewSelectionChanged;
				
				BtNewProject.Clicked += HandleBtNewProjectClicked;			
				BtRmProject.Clicked += HandleBtRmProjectClicked;
				BtAddGrid.Clicked += HandleBtAddGridClicked;
				BtRemoveGrid.Clicked += HandleBtRemoveGridClicked;
			
				/*******************************************************/
				/* FI Gestió Finestres PRojects i Grids                */
				/*******************************************************/
				
			}

			public void LoadProjects(){
				TreeStore ProjectStore=new TreeStore(typeof(Gdk.Pixbuf),typeof(string));
				string dir_grids=Amic.GridCreator.Preferences.dir_grids;
				Gdk.Pixbuf PixBufFolder=new Gdk.Pixbuf (Amic.GridCreator.Preferences.dir_default+"/IconFolder.png", 20, 20);
				string gridname="";
				foreach(string dir in System.IO.Directory.GetDirectories(dir_grids)){
					gridname=dir.Replace(dir_grids+"/","");
					if (gridname!="xsd"&&gridname.Contains(".AmicProject"))
					{
						ProjectStore.AppendValues(PixBufFolder, gridname.Replace(".AmicProject", ""));
					}
				}
				
				TreeModelFilter TMFilter=new TreeModelFilter(ProjectStore, null);
				TreeModelSort sortAdapter=new TreeModelSort(TMFilter);
				ProjectsTreeView.Model=sortAdapter;
				
				ProjectsTreeView.ShowAll();
				ProjectsTreeView.Show();
			}
			
			void HandleBtRemoveGridClicked (object sender, EventArgs e)
			{
				Amic.GridCreator.Core core=Amic.GridCreator.Core.getCore();	
				string path="";
				if(core.CurrentProjectName!=""&&core.CurrentProjectName!=null&&
				   core.openedGrid!=null&&core.openedGrid.name!=""){
					Console.WriteLine(core.CurrentProjectName);
					path=Amic.GridCreator.Preferences.dir_grids+"/"+core.CurrentProjectName+".AmicProject/"+core.openedGrid.name+".grid";
					Console.WriteLine("path:"+path);
					if(System.IO.File.Exists(path))
					{
						MessageDialog md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
				      	                              			MessageType.Question, ButtonsType.YesNo, 
				          	                          			Mono.Unix.Catalog.GetString("Do you really want to remove grid ")+core.openedGrid.name+Mono.Unix.Catalog.GetString(" from project?"));
						ResponseType result = (ResponseType)md.Run();
					
						md.Destroy();
			
						if (result==ResponseType.Yes){
							Console.WriteLine("Removing Grid: "+path);	
							System.IO.File.Delete(path);
							
							// Eliminem el grid de la pantalla
							if(Amic.GridCreator.Core.getCore().current!=null)
							{
								vbox_grid.Remove(Amic.GridCreator.Core.getCore().current);
								Console.WriteLine("[MainWindow] Removing old grid matrix...");
								Amic.GridCreator.Core.getCore().current=null;
							}
							
							RefreshGridWindow(core.CurrentProjectName, "");
						} // (end if System.IO.FILE.EXISTS....)
					}
					else Console.WriteLine("Not Exists: "+path);
					
					
					
				}
			}
			
			void HandleBtAddGridClicked (object sender, EventArgs e)
			{
				string projectname=Amic.GridCreator.Core.getCore().CurrentProjectName;
				if(projectname!=""&&projectname!=null){
					Console.WriteLine("[MainWindow] Creating new grid...");
					Amic.GridCreator.Core.getCore().newgridwin=new Amic.GridCreator.NewGridWindow();
					Amic.GridCreator.Core.getCore().openedGrid=new Amic.GridCreator.Grid();
					
					GridCreator.Core.getCore().CurrentFileSaved=false; // per indicar que s'ha de gravar!
				}
			}

			void HandleBtRmProjectClicked (object sender, EventArgs e)
			{
				Amic.GridCreator.Core core=Amic.GridCreator.Core.getCore();	
				string dirpath=GridCreator.Preferences.dir_grids+"/"+core.CurrentProjectName+".AmicProject/";
				if(System.IO.Directory.Exists(dirpath)){
					Console.WriteLine("Exists; "+dirpath);
					string [] nfiles=System.IO.Directory.GetFiles(dirpath, "*.grid");
					
					MessageDialog md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
				      	                              		MessageType.Question, ButtonsType.YesNo, 
				          	                          		Mono.Unix.Catalog.GetString("Do you want to remove the project ")+Amic.GridCreator.Core.getCore().CurrentProjectName+Mono.Unix.Catalog.GetString(" with ")+nfiles.Length+Mono.Unix.Catalog.GetString(" grids?"));
					ResponseType result = (ResponseType)md.Run();

					md.Destroy();
		
					if (result==ResponseType.Yes){
						try{
							System.IO.Directory.Delete(dirpath, true);
							core.CurrentFileSaved=true; // Per a que no intente gravar res
							core.CurrentProjectName=null;
							core.win.LoadProjects();
						} catch (Exception exc){
							Console.WriteLine(exc.Message);
						}
					}
					
					
					
					
						
				} else Console.WriteLine("NOT Exists; "+dirpath);
			}

			void HandleBtNewProjectClicked (object sender, EventArgs e)
			{
				Amic.GridCreator.NewProject NewProjectDlg=new Amic.GridCreator.NewProject();
				NewProjectDlg.Show();
			}

			
			
			void HandleGridsTreeViewSelectionChanged (object sender, EventArgs e)
			{
				Amic.GridCreator.Core core=Amic.GridCreator.Core.getCore();	
				
						Console.WriteLine("1111"+core.CurrentFileToSave+"4444222");
				TreeStore GridStore=new TreeStore(typeof(Gdk.Pixbuf),typeof(string));
				TreeModel model;
				TreeIter iterSelected;
				string path="";
				GridStore.Clear();
				
				if(((TreeSelection)sender).GetSelected (out model, out iterSelected))
						path = (string) model.GetValue (iterSelected, 2);				
				
				
				// Comprovem primer si s'ha editat el grid per gravar-lo
				if (core.CurrentFileSaved==false){
					
					Console.WriteLine("1111"+core.CurrentFileToSave+"4444");
					MessageDialog md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
				      	                              		MessageType.Question, ButtonsType.YesNo, 
				          	                          		Mono.Unix.Catalog.GetString("The grid ")+core.openedGrid.name+Mono.Unix.Catalog.GetString(" has not been saved. Do you want to save it?"));
					ResponseType result = (ResponseType)md.Run();

					md.Destroy();
		
					if (result==ResponseType.Yes){
						try{
							if(core.openedGrid==null||core.openedGrid.name==null||core.openedGrid.name==""||core.CurrentProjectName==""||core.CurrentProjectName==null){
								Console.WriteLine("No té nom...");
							} else{
								string file=core.CurrentFileToSave;
								//						string file=Amic.GridCreator.Preferences.dir_grids+"/"+core.CurrentProjectName+".AmicProject/"+core.openedGrid.name+".grid";

								Console.WriteLine("Writing... "+file);
								// I actualitzem l'estat...
								core.CurrentFileSaved=true;
								Console.WriteLine("EL POSE A FALSE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
								
								Amic.GridCreator.Core.getCore().xmlman.saveFile(file, null); // 2on paràmetre null -> Save del grid actual
								RefreshGridWindow(core.CurrentProjectName, core.openedGrid.name);
							}
							}
						catch (Exception exc) {
								Console.WriteLine("Exception Saving: "+exc);
						}
					}
				}
				
				Console.WriteLine("GRID: "+path);
				
				// Actualitzem el nom del path per saber què guardar
				GridCreator.Core.getCore().CurrentFileToSave=path;
				GridCreator.Core.getCore().CurrentFileSaved=true;
						
				if(System.IO.File.Exists(path)) {
					core.xmlman.loadFileAlt(path);
					if (core.openedGrid.pictogram_list.Count>0)
					{
						core.openedCategories=new System.Collections.Generic.List<string>();
						core.openedCategories=core.openedGrid.pictogram_list[0].getCategories();
						Console.WriteLine("!");
						store.Clear();
						foreach(string str in core.openedCategories)
						{
							Console.WriteLine("#> " + str);
							store.AppendValues(str);
							
						}
						
						themeCombobox.Active=0;
						core.CurrentFileSaved=true; // No caldrà gravar-lo
						
					}

					
					
					
					core.gridWidget=new Amic.GridCreator.GridWidget();
					//core.gridWidget.init(core.openedGrid.width,core.openedGrid.height);
				//	Console.WriteLine("hetherrrr");
					core.gridWidget.loadFromFile();
				//	Console.WriteLine("hetherrrr");
				//	core.gridWidget.init(core.openedGrid.width,core.openedGrid.height);
					
					core.win.showGrid();
					
					
				}
			}

			
			void RefreshGridWindow(string actualSelectedProject, string NewGrid){
				
				GlobalSelectedProject=actualSelectedProject; // Per poder passar-lo al conversor de plaphoons
				Console.WriteLine("CurrentProject: "+GlobalSelectedProject);
				
				TreeStore GridStore=new TreeStore(typeof(Gdk.Pixbuf),typeof(string), typeof(string));

				try{
				
					GridStore.Clear();
					Console.WriteLine(actualSelectedProject);
					Console.WriteLine(GridCreator.Core.getCore().CurrentFileToSave);
					if(actualSelectedProject!=""&&actualSelectedProject!=null){
						// Actualitzem el nom del projecte actual
						Amic.GridCreator.Core.getCore().CurrentProjectName=actualSelectedProject;
						
						Console.WriteLine("REFRESHING "+actualSelectedProject+"!!!!!!!!!!");
						
						string gridname=""; 
						string dir_grids=Amic.GridCreator.Preferences.dir_grids;
						Gdk.Pixbuf PixBufFile=new Gdk.Pixbuf (Amic.GridCreator.Preferences.dir_default+"/IconFile.png", 20, 20);
						// Carreguem tots els grids del projecte (carpeta)					
						foreach(string dir in System.IO.Directory.GetFiles(Amic.GridCreator.Preferences.dir_grids+"/"+actualSelectedProject+".AmicProject",  "*.grid"))
						{
							// Comprovem que tinga més de 0 bytes...
							System.IO.FileInfo f=new System.IO.FileInfo(dir);
							if (f.Length>0){
								gridname=dir.Replace(dir_grids+"/"+actualSelectedProject+".AmicProject/","");
								gridname=gridname.Replace(".grid","");
								
								GridStore.AppendValues(PixBufFile, gridname, dir);
							}
						}
				
					}
					TreeModelFilter TMFilter=new TreeModelFilter(GridStore, null);
					TreeModelSort sortAdapter=new TreeModelSort(TMFilter);
						
					//this.msgLabel.Text="Saved "+NewGrid;
						
					GridsTreeView.Model=sortAdapter;
					GridsTreeView.ShowAll();
					GridsTreeView.Show();	
					
					// I netegem la finestra dels grids
					/*if(Amic.GridCreator.Core.getCore().current!=null)
						{
							vbox2.Remove(Amic.GridCreator.Core.getCore().current);
							Console.WriteLine("[MainWindow] Removing old grid matrix...");
							Amic.GridCreator.Core.getCore().current=null;
						}*/
					
			
			} catch (Exception exc){
				Console.WriteLine("Excepcio: "+exc);
			}	
			}
			
			void HandleProjectsTreeViewSelectionChanged (object sender, EventArgs e)
			{
				TreeModel model;
				TreeIter iterSelected;
				string actualSelectedProject="";
				
				if(((TreeSelection)sender).GetSelected (out model, out iterSelected)) {
						actualSelectedProject = (string) model.GetValue (iterSelected, 1);
					}
				
				RefreshGridWindow(actualSelectedProject,"");
				
					// I netegem la finestra dels grids
					if(Amic.GridCreator.Core.getCore().current!=null)
						{
							vbox_grid.Remove(Amic.GridCreator.Core.getCore().current);
							Console.WriteLine("[MainWindow] Removing old grid matrix...");
							Amic.GridCreator.Core.getCore().current=null;
						}
				
			
			}
		
			public string message
			{
				set
				{
					msgLabel.Text=value;	
				}
				
			}
			
			public void showGrid()
			{
				
				
				if(Amic.GridCreator.Core.getCore().current!=null)
				{
					vbox_grid.Remove(Amic.GridCreator.Core.getCore().current);
					Console.WriteLine("[MainWindow] Removing old grid matrix...");
				}
				
				Console.WriteLine("[MainWindow] Showing grid matrix...");
				Amic.GridCreator.Core.getCore().current=Amic.GridCreator.Core.getCore().gridWidget;
				Amic.GridCreator.Core.getCore().current.ShowAll();
				
				vbox_grid.PackStart(Amic.GridCreator.Core.getCore().current, false, false, 0);
				//vbox_grid.Add(Amic.GridCreator.Core.getCore().current);
				
				
			}
			
			
			protected void OnDeleteEvent (object sender, DeleteEventArgs a)
			{
				Application.Quit();
				//GridCreator.Core.getCore().win.Destroy(); // JA
				a.RetVal = true;
			}
			protected virtual void OnNewGridButtonClicked (object sender, System.EventArgs e)
			{			

				Amic.GridCreator.Core core=Amic.GridCreator.Core.getCore();	

				// TODO: Comprovar si s'ha gravat...
				string projectname=Amic.GridCreator.Core.getCore().CurrentProjectName;
				if(projectname!=""&&projectname!=null){
					Console.WriteLine("[MainWindow] Creating new grid...");
					core.newgridwin=new Amic.GridCreator.NewGridWindow();
					core.openedGrid=new Amic.GridCreator.Grid();
				
					GridCreator.Core.getCore().CurrentFileSaved=false; // per indicar que s'ha de gravar!

				}
				
			}
			
			protected virtual void OnOpenGridButtonClicked (object sender, System.EventArgs e)
			{

				openDialog();
				
			}
			
			public void openSelectWindow()
			{
				Amic.GridCreator.Core.getCore().selectwin=new Amic.GridCreator.SelectPictogramWindow();
			}
			
			
			
			protected virtual void OnNewActionActivated (object sender, System.EventArgs e)
			{
				Console.WriteLine("[MainWindow] Clicked on new grid menu");
				Amic.GridCreator.Core.getCore().newgridwin=new Amic.GridCreator.NewGridWindow();
			}
			
			protected virtual void OnOpenActionActivated (object sender, System.EventArgs e)
			{

				openDialog();				
						
			}
			
			protected virtual void OnSaveGridButtonClicked (object sender, System.EventArgs e)
			{
				try{
					Amic.GridCreator.Core core=Amic.GridCreator.Core.getCore();
					
					if(core.openedGrid==null||core.openedGrid.name==null||core.openedGrid.name==""||core.CurrentProjectName==""||core.CurrentProjectName==null||core.CurrentFileSaved==true){
						Console.WriteLine("No té nom o no cal gravar-lo...");
						Console.WriteLine("Current Project: *"+core.CurrentProjectName+"* - openedgrid: *"+core.openedGrid.name+"*");
					} else{
					
						string file=Amic.GridCreator.Preferences.dir_grids+"/"+core.CurrentProjectName+".AmicProject/"+core.openedGrid.name+".grid";
					
						Console.WriteLine("Writing... "+file);
						Amic.GridCreator.Core.getCore().xmlman.saveFile(file, null);
						// Indiquem que no cal ja gravar-lo
						Amic.GridCreator.Core.getCore().CurrentFileSaved=true;
						RefreshGridWindow(core.CurrentProjectName, core.openedGrid.name);

					}
					
					
					/*Gtk.FileChooserDialog dialog=new Gtk.FileChooserDialog("Save file to...",null,Gtk.FileChooserAction.Save);
					
					dialog.AddButton("Cancel",Gtk.ResponseType.Cancel);
					dialog.AddButton("Accept",Gtk.ResponseType.Ok);
					Gtk.ResponseType result=(Gtk.ResponseType)dialog.Run();
					string file=dialog.Filename;
					if(result==Gtk.ResponseType.Ok)
					{
						file=dialog.Filename;
						dialog.Destroy();
						Amic.GridCreator.Core.getCore().xmlman.saveFile(file);
					}
					else
						if(result==Gtk.ResponseType.Cancel || result==Gtk.ResponseType.DeleteEvent)
							dialog.Destroy();				
					
					//Amic.GridCreator.Core.getCore().xmlman.saveFile("test.xml");
					*/
				} catch (Exception exc){
					Console.WriteLine("Exception Saving: "+exc);
				}
			}
			
			protected virtual void OnThemeComboboxChanged (object sender, System.EventArgs e)
			{
				//Amic.GridCreator.Core.getCore().openedCategories=themeCombobox.ActiveText;
				
				if(Amic.GridCreator.Core.getCore().gridWidget!=null)
					Amic.GridCreator.Core.getCore().gridWidget.QueueDraw();
			}
			
			public string selectedTheme
			{
				get
				{
					return themeCombobox.ActiveText;	
				}
			}
			
			public void openDialog()
			{
				Console.WriteLine("[MainWindow] Opening an existing grid...");
				
				Gtk.FileChooserDialog dialog=new Gtk.FileChooserDialog("Open a grid...",null,Gtk.FileChooserAction.Open);
				dialog.AddButton("Cancel",Gtk.ResponseType.Cancel);
				dialog.AddButton("Accept",Gtk.ResponseType.Ok);
				Gtk.FileFilter filter=new Gtk.FileFilter();
				filter.AddPattern("*.grid");
				dialog.Filter=filter;
				Gtk.ResponseType result=(Gtk.ResponseType)dialog.Run();
				string file=dialog.Filename;
				if(result==Gtk.ResponseType.Ok)
				{
					file=dialog.Filename;
					dialog.Destroy();
					Console.WriteLine("Selecting " + file + " ...");
					Amic.GridCreator.Core core=Amic.GridCreator.Core.getCore();
				//	core.xmlman.loadFile(file);
					core.xmlman.loadFileAlt(file);
					if (core.openedGrid.pictogram_list.Count>0)
					{
						core.openedCategories=new System.Collections.Generic.List<string>();
						core.openedCategories=core.openedGrid.pictogram_list[0].getCategories();
						Console.WriteLine("!");
						store.Clear();
						foreach(string str in core.openedCategories)
						{
							Console.WriteLine("#> " + str);
							store.AppendValues(str);
							
						}
						
						themeCombobox.Active=0;
						
					}

					
					
					
					core.gridWidget=new Amic.GridCreator.GridWidget();
					//core.gridWidget.init(core.openedGrid.width,core.openedGrid.height);
				//	Console.WriteLine("hetherrrr");
					core.gridWidget.loadFromFile();
				//	Console.WriteLine("hetherrrr");
				//	core.gridWidget.init(core.openedGrid.width,core.openedGrid.height);
					
					core.win.showGrid();
				}
				else
					if(result==Gtk.ResponseType.Cancel || result==Gtk.ResponseType.DeleteEvent)
						dialog.Destroy();
				
				
							
			}
			
			public void goToDefault()
			{
				themeCombobox.Active=0;	
			}
			
			protected virtual void onArchiveProjectActivate (object sender, System.EventArgs e)
			{
				Console.WriteLine("PROJECT: "+Amic.GridCreator.Core.getCore().CurrentProjectName);
				if(Amic.GridCreator.Core.getCore().CurrentProjectName=="")
				{
					Console.WriteLine("NOT DEFINED");
					
				} else{
					Console.WriteLine("Archive");
					DlgExportArchive dlgExport=new DlgExportArchive(Amic.GridCreator.Core.getCore().CurrentProjectName);
					dlgExport.Show();
				}
				
			}
			
			protected virtual void onImportArchiveArchivated (object sender, System.EventArgs e)
			{
				FileChooserDialog dialog=new FileChooserDialog(Mono.Unix.Catalog.GetString("Select Archive "),Amic.GridCreator.Core.getCore().win , Gtk.FileChooserAction.Open);
				dialog.AddButton("Cancel", ResponseType.Cancel);
				dialog.AddButton("Accept", ResponseType.Accept);
				//dialog.SetCurrentFolder(Directory);
				
				FileFilter ArxiusApz=new FileFilter();
				ArxiusApz.AddPattern("*.apz");
				dialog.AddFilter(ArxiusApz);
				dialog.Modal=true;
		 		dialog.Response += HandleDialogOpenApzResponse;
				dialog.Run();
				
				// Recarreguem els projectes
				GridCreator.Core.getCore().CurrentFileSaved=true; // Per a que no intente gravar res
				GridCreator.Core.getCore().CurrentProjectName=null;
				GridCreator.Core.getCore().win.LoadProjects();
			
			
			}
			
			
			void HandleDialogOpenApzResponse (object o, ResponseArgs args)
			{
			if (args.ResponseId == Gtk.ResponseType.Accept){
					string filename=((Gtk.FileChooserDialog)o).Filename;
					Console.WriteLine("**"+filename);
					Archiver.ImportArchive(filename);
					
					
				}
				((Gtk.FileChooserDialog)o).Destroy();
				
			}	
			
			
			
			protected virtual void onImportFromPlaphoonsActivated (object sender, System.EventArgs e)
			{
				
				// Comprovem si té un projecte seleccionat
				if(GlobalSelectedProject!=""){
					FileChooserDialog dialog=new FileChooserDialog(Mono.Unix.Catalog.GetString("Select Plaphoons Archive "),Amic.GridCreator.Core.getCore().win , Gtk.FileChooserAction.Open);
					
					FileFilter f=new FileFilter();
					f.AddPattern("*.pla");
					dialog.AddFilter(f);
					
					dialog.AddButton("Cancel", ResponseType.Cancel);
					dialog.AddButton("Accept", ResponseType.Accept);
					//dialog.SetCurrentFolder(Directory);
									
					dialog.Modal=true;
			 		dialog.Response += HandleDialogImportPlaResponse;
					dialog.Run();
					
					// Recarreguem els projectes
					GridCreator.Core.getCore().CurrentFileSaved=true; // Per a que no intente gravar res
					GridCreator.Core.getCore().CurrentProjectName=null;
					GridCreator.Core.getCore().win.LoadProjects();
				
				
				} else { // No té projecte seleccionat. Cal avisar l'usuari
					MessageDialog md = new MessageDialog (GridCreator.Core.getCore().win , DialogFlags.DestroyWithParent,
				      	                              		MessageType.Warning, ButtonsType.Close,
				          	                          		Mono.Unix.Catalog.GetString("You need to select a projet to import in the grids"));
					md.Run();
					md.Destroy();
				}
					
					
			}

			void HandleDialogImportPlaResponse (object o, ResponseArgs args)
			{
				if (args.ResponseId == Gtk.ResponseType.Accept){
					string filename=((Gtk.FileChooserDialog)o).Filename;
					Console.WriteLine("**"+filename);
					
					// Importem l'arxiu seleccionat al projecte actual
					System.Collections.Generic.List<string> imported=new System.Collections.Generic.List<string>();
					Archiver.ImportFromPla(filename, GlobalSelectedProject, "first", imported);
				}
				((Gtk.FileChooserDialog)o).Destroy();
			
			}
			
			protected virtual void onNewProjectActivated (object sender, System.EventArgs e)
			{
				Amic.GridCreator.NewProject NewProjectDlg=new Amic.GridCreator.NewProject();
				NewProjectDlg.Show();
				
			}
			
			
			
			
			
			
		}
	}
	
}
