using System;
using Gtk;
using Glade;
using System.IO;

namespace Amic{
	namespace GridCreator
	{
		public class NewProject : Dialog
		{
			[Widget] Gtk.Dialog NewProjectDialog;
			[Widget] Gtk.Entry ProjectName;
			[Widget] Gtk.TextView Authors;
			[Widget] Gtk.TextView Desc;
			[Widget] Gtk.Button BtCancel;
			[Widget] Gtk.Button BtOk;
		
			public NewProject ()
			{
				Application.Init ();
					
				Glade.XML gxml = new Glade.XML(null, "NewProjectDialog.glade", "NewProjectDialog", null);
				gxml.Autoconnect (this);
				
				BtOk.Clicked += HandleBtOkClicked;
				BtCancel.Clicked += HandleBtCancelClicked;
					
			}

			void HandleBtCancelClicked (object sender, EventArgs e)
			{
				Application.Quit();
				NewProjectDialog.Destroy();
			}

			void HandleBtOkClicked (object sender, EventArgs e)
			{
				if(ProjectName.Text=="") {
					MessageDialog md = new MessageDialog (NewProjectDialog , DialogFlags.DestroyWithParent,
				      	                              		MessageType.Question, ButtonsType.Close, 
				          	                          		Mono.Unix.Catalog.GetString("You should specify a name for the project."));
					md.Modal=true;
					md.Run();
					md.Destroy();
				}
				else{
					string path=Amic.GridCreator.Preferences.dir_grids+"/"+ProjectName.Text+".AmicProject";
					System.IO.Directory.CreateDirectory(path);
					if(System.IO.Directory.Exists(path)){
						FileStream fs=null;
						StreamWriter sw=null;
						try{
							fs = new FileStream(path+"/"+"authors.txt", System.IO.FileMode.CreateNew);
							sw=new StreamWriter(fs);
							sw.WriteLine("LliureX Amic Project v. 1.0: "+ProjectName.Text);
							sw.WriteLine();
							sw.WriteLine("Authors:");
							sw.WriteLine(Authors.Buffer.Text);
							sw.WriteLine();
							sw.WriteLine("Description:");
							sw.WriteLine(Desc.Buffer.Text);
							sw.WriteLine();
							sw.WriteLine("Licensed under the therms of Creative Commons BY-NC-SA license. (http://creativecommons.org/licenses/by-nc-sa/3.0/)");
							sw.Close();
							// Recarreguem els projectes
							GridCreator.Core.getCore().win.LoadProjects();
						}catch (Exception exc){
							Console.WriteLine("Excepcio escrivint: "+exc);
							if (sw!=null) sw.Close();
				
						}
					}
					
					
					Application.Quit();
					NewProjectDialog.Destroy();
				}
			}
			
			public new void Show(){
					NewProjectDialog.ShowAll();
					NewProjectDialog.Modal=true;
					NewProjectDialog.SetPosition(WindowPosition.CenterAlways);
					Application.Run();			
				}
				
				
			
			
		}
}
}
