
using System;

namespace Amic
{

	namespace GridCreator
	{	
		public partial class SelectPictogramWindow : Gtk.Window
		{

			const int COL_PATH = 0;
			const int COL_DISPLAY_NAME = 1;
			const int COL_PIXBUF = 2;
			const int COL_IS_DIRECTORY = 3;
			
			
			
			public System.Collections.Generic.List<Category> categories;
			public System.Xml.XmlDocument xml;
			////public string base_path="/usr/share/lliurex-amic/xml/galleries/";
			//public string base_path="/var/lib/lliurex-amic/xml/galleries/";
			public string base_path=GridCreator.Preferences.dir_gallery+"/";
			////public string base_grids="/usr/share/lliurex-amic/grids";
			//public string base_grids=GridCreator.Preferences.dir_grids;
			string base_grids=GridCreator.Preferences.dir_grids+"/"+GridCreator.Core.getCore().CurrentProjectName+".AmicProject/";
			//public string base_grids="/var/lib/lliurex-amic/xml/grids";
			
			public Gtk.ListStore store;
			public Amic.GridCreator.Pictogram selected_pictogram;
			
			public Gtk.ListStore combo_store;
			public Gtk.ListStore options_store;
			public System.Collections.Generic.List<string> theme_list;
			
			public Gtk.ListStore theme_store;
			
			public struct Category
			{
				public string name;
				public string default_color;
				public System.Collections.Generic.List<Amic.GridCreator.Pictogram> pic_list;
			}
			
			
			
			public SelectPictogramWindow () : base(Gtk.WindowType.Toplevel)
			{
				this.Build ();
				
				theme_list=new System.Collections.Generic.List<string>();
				
				categories=new System.Collections.Generic.List<Amic.GridCreator.SelectPictogramWindow.Category>();
				string[] xmls=System.IO.Directory.GetFiles(base_path);
				
				theme_store=new Gtk.ListStore(typeof(string));
			
				themeCombobox.Model=theme_store;
				
				Amic.GridCreator.SelectPictogramWindow.Category cat;
				foreach(string file in xmls)
				{
					//readcategoriesXML(file);	
					if(file.Contains(".xml"))
					{
						cat=Amic.GridCreator.Core.getCore().xmlman.loadCategory(file);
					
						categories.Add(cat);
					}
					
				}
				
		//		readcategoriesXML(base_path + "Casa.xml");
				
				Gtk.TreeViewColumn namecol=new Gtk.TreeViewColumn();
				namecol.Title="Category";
				Gtk.CellRendererText cell=new Gtk.CellRendererText();
				
				namecol.PackStart(cell,true);
				namecol.AddAttribute(cell,"text",0);				
				
				Categorytreeview.AppendColumn(namecol);
				store=new Gtk.ListStore(typeof(string));
				
				Categorytreeview.Model=store;
				Categorytreeview.ShowAll();
				
				
			
			 
			 	
				foreach(Category cat2 in categories)
				{
					store.AppendValues(cat2.name);
				}			 		
			 			
			 					
			
				
				actionCombobox.Sensitive=false;
				
			}

			protected virtual void OnCategorytreeviewCursorChanged (object sender, System.EventArgs e)
			{
				
				Gtk.TreeModel model;
				Gtk.TreeIter iter;
				Categorytreeview.Selection.GetSelected(out model,out iter);
				//if(model.GetValue(iter,0)==)
				//Console.WriteLine("click {0}",model.GetValue(iter,0));
				foreach(Category cat in categories)
				{
					
					
					if(cat.name.CompareTo(model.GetValue(iter,0))==0)
					{
						//Console.WriteLine(cat.name);
						
						
						Gtk.ListStore store=new Gtk.ListStore(typeof (Gdk.Pixbuf), typeof(string),typeof(Amic.GridCreator.Pictogram),typeof(string));

						
						pictoIconview.PixbufColumn=0;
						pictoIconview.TextColumn=1;
						
			
						
						foreach(Amic.GridCreator.Pictogram p in cat.pic_list)
						{
							
							
								//Console.WriteLine(p.pictname);
								foreach(System.Collections.Generic.KeyValuePair<string,string> key in p.image_list)
								{
									if(key.Key=="Default")
									{
										Gdk.Pixbuf buf=null;
										string path=GridCreator.Core.getCore().amic_images + key.Value;
										if(System.IO.File.Exists(path))
										{
											buf=new Gdk.Pixbuf(Amic.GridCreator.Core.getCore().amic_images+key.Value);
										}
										else
											buf=new Gdk.Pixbuf("/usr/share/icons/LliureX/scalable/stock/gtk-cancel.svg");
										
										buf=buf.ScaleSimple(150,150,Gdk.InterpType.Bilinear);
										store.AppendValues(buf,p.pictname,p,key.Value);
									}
							
								}
							
						}
						pictoIconview.Model=store;
						
					}
				}					
				
				
			}
			
			protected virtual void OnPictoIconviewSelectionChanged (object sender, System.EventArgs e)
			{
				try
				{
					Console.WriteLine("[SelectPictogramWindow] Selection changed...");
					
					Gtk.TreePath path=pictoIconview.SelectedItems[0];
					Gtk.TreeIter iter;
				
					pictoIconview.Model.GetIter(out iter,path);
				
					selected_pictogram=(Amic.GridCreator.Pictogram)pictoIconview.Model.GetValue(iter,2);
					selected_pictogram.image=(string)pictoIconview.Model.GetValue(iter,3);
				
					
					actionCombobox.Sensitive=true;
					
					combo_store=new Gtk.ListStore(typeof(string));
					combo_store.AppendValues("Play Sound: " + selected_pictogram.actionSound);
					combo_store.AppendValues("Speech: " + selected_pictogram.actionSpeech);
					
					combo_store.AppendValues("Open Child");
					combo_store.AppendValues("Go back to Parent");
					
					actionCombobox.Model=combo_store;
					actionCombobox.ShowAll();
					actionCombobox.Active=1;
					
					
					
				//Amic.GridCreator.Core.getCore().gridWidget.refreshPic(p);
				}
				catch
				{
					
				}
				
				
			}
			
			protected virtual void OnButton6Clicked (object sender, System.EventArgs e)
			{
				this.Destroy();
			}
			
			protected virtual void OnAcceptButtonClicked (object sender, System.EventArgs e)
			{
				if(selected_pictogram!=null)
				{
					if(actionCombobox.ActiveText.Contains("Speech"))
						selected_pictogram.actionType="speech";
					if(actionCombobox.ActiveText.Contains("Play"))
						selected_pictogram.actionType="sound";
					if(actionCombobox.ActiveText.Contains("Child"))
					{
						selected_pictogram.actionType="child";
						selected_pictogram.actionValue=childCombobox.ActiveText;
					}
					if(actionCombobox.ActiveText.Contains("Parent"))
					{
						selected_pictogram.actionType="parent";
						selected_pictogram.actionValue="goback";
					}
					
					
					Amic.GridCreator.Core.getCore().gridWidget.refreshPic(selected_pictogram);
				//	Amic.GridCreator.Core.getCore().editgridwin.Destroy();
					Amic.GridCreator.Core.getCore().CurrentFileSaved=false; // Caldrà gravar la imatge
					this.Destroy();
					
				}
			}
			
		
			protected virtual void OnChildComboboxChanged (object sender, System.EventArgs e)
			{
				
				
				
			}
			
			protected virtual void OnActionComboboxChanged (object sender, System.EventArgs e)
			{
				
				if(actionCombobox.ActiveText.Contains("Child"))
				{
					childCombobox.Sensitive=true;
					options_store=new Gtk.ListStore(typeof(string));
					
					Console.WriteLine("BASE**:"+base_grids+"!***");
					
					string[] file_list=System.IO.Directory.GetFiles(base_grids);
				
					foreach(string file in file_list)
						if(file.Substring(file.Length-5, 5)==".grid")
							options_store.AppendValues(file.Replace(base_grids,"").Replace(".grid",""));

						//options_store.AppendValues(file.Replace(base_grids+"/",""));
					childCombobox.Model=options_store;
					childCombobox.Active=0;
					childCombobox.ShowAll();
					
				}
				else
					childCombobox.Sensitive=false;
			}
			
			
			
			
			
			
			
			
			
			
			
			
		}
	}
}
