
using System;

namespace Amic
{

	namespace GridCreator
	{
		public class XmlManager
		{
	
			public Amic.GridCreator.Grid grid;
			public System.Xml.XmlDocument xml;
			
			public XmlManager ()
			{
				
				xml=new System.Xml.XmlDocument();
				grid=new Grid();
				
			}
			
			public void saveFile(string path, GridCreator.Grid grid)
			{
				// Si el paràmetre grid és null, agafa el grid actual des del core.
				try
				{
					int num_pic_no_name=0;
					
					System.Xml.XmlTextWriter writer=new System.Xml.XmlTextWriter(path,System.Text.Encoding.UTF8);
					writer.Formatting=System.Xml.Formatting.Indented;
					writer.WriteStartDocument();
					if (grid==null)
						grid=Amic.GridCreator.Core.getCore().openedGrid;
					writer.WriteStartElement("grid");
					writer.WriteAttributeString("xmlns:xsi","http://www.w3.org/2001/XMLSchema-instance");
					
						writer.WriteStartElement("gridname");
						writer.WriteString(grid.name);
						writer.WriteEndElement();
						
						/*
						writer.WriteStartElement("class");
						writer.WriteString(grid.class_);
						writer.WriteEndElement();
						*/
						writer.WriteStartElement("width");
						writer.WriteString(Convert.ToString(grid.width));
						writer.WriteEndElement();
					
						writer.WriteStartElement("height");
						writer.WriteString(Convert.ToString(grid.height));
						writer.WriteEndElement();
					
						writer.WriteStartElement("pictograms");
						
							Console.WriteLine(grid.pictogram_list.Count);
					
							foreach(Amic.GridCreator.Pictogram p in grid.pictogram_list)
							{						
								p.printMe();
								// Patch per si align és buit:
								if(p.align!="top") p.align="bottom";
						
								writer.WriteStartElement("pictogram");
								writer.WriteAttributeString("row",Convert.ToString(p.row));
								writer.WriteAttributeString("col",Convert.ToString(p.col));
						
									writer.WriteStartElement("pictname");
									
									if(p.pictname!=null)
										writer.WriteString(p.pictname);
									else
										{writer.WriteString("unnamed-"+num_pic_no_name.ToString());							
										num_pic_no_name++;}
									writer.WriteEndElement();					
						
									writer.WriteStartElement("background");
									writer.WriteString(p.background);
									writer.WriteEndElement();
									/*
									writer.WriteStartElement("image");
									writer.WriteString(p.image);
									writer.WriteEndElement();
									*/
						
									writer.WriteStartElement("images");
						
										// Patch per si no s'han indicat imatges...
										Console.WriteLine("El picto te "+p.image_list.Count+" imatges!!!!!!!!!!!!!!!!!!!");
										if (p.image_list.Count>0) 
							            foreach(System.Collections.Generic.KeyValuePair<string,string> key in p.image_list)
										{
					
												writer.WriteStartElement("image");
												writer.WriteStartElement("theme");
												writer.WriteString(key.Key);
												writer.WriteEndElement(); // Theme
												writer.WriteStartElement("source");
												writer.WriteString(key.Value);
												writer.WriteEndElement();
											writer.WriteEndElement();
							
										}
										else {
												writer.WriteStartElement("image");
												writer.WriteStartElement("theme");
												writer.WriteString("Default"); // diem el tema per defecte
												writer.WriteEndElement();
												writer.WriteStartElement("source");
												writer.WriteString("undefined.png");
												writer.WriteEndElement();
										writer.WriteEndElement();
							
										}
										
						
									
									writer.WriteEndElement();
						
									writer.WriteStartElement("caption");
									
									writer.WriteAttributeString("fontface",p.fontFace);
									writer.WriteAttributeString("size",Convert.ToString(p.fontSize));
									writer.WriteAttributeString("typeface",p.fontTypeFace);
									writer.WriteAttributeString("color",p.fontColor);
									writer.WriteAttributeString("align",p.align);
						
									writer.WriteString(p.caption);
									writer.WriteEndElement();
						
									writer.WriteStartElement("action");
										
										Console.WriteLine("ACTION:"+p.actionType);
										Console.WriteLine("ACTION cHILd:"+p.actionChild);
										switch(p.actionType)
										{
											case "speech":
												writer.WriteStartElement("speech");
												writer.WriteString(p.actionSpeech);						
												break;
											case "sound":
												writer.WriteStartElement("sound");
												writer.WriteString(p.actionSound);						
												break;
											case "child":
												writer.WriteStartElement("child");
												writer.WriteString(p.actionChild);
												break;
											case "parent":
												writer.WriteStartElement("parent");
												writer.WriteString(p.actionValue);
												break;
							
											default:
												// Patch per 
												writer.WriteStartElement("sound"); 
												writer.WriteString(p.actionSound);						
												break;
												//Console.WriteLine("aquiii");
												//break;
							
							// TODO: Queda per vore quan creem un grid nou, si es grava i no és del tot complet, 
							// grava les coses en blanc i casca al carregar
										}
						
						
										
	
										
									writer.WriteEndElement();
								writer.WriteEndElement();
							writer.WriteEndElement();
						
	
	
							}
					
					
					
					writer.WriteEndDocument();
					writer.Close();
				}
				catch(Exception e)
				{
					Console.WriteLine(e);
				}
					
				
			}
			
			public Amic.GridCreator.SelectPictogramWindow.Category loadCategory(string path)
			{
				
				
				Amic.GridCreator.SelectPictogramWindow.Category cat=new Amic.GridCreator.SelectPictogramWindow.Category();
				

				System.Xml.XmlTextReader reader=new System.Xml.XmlTextReader(path);
				
				Console.WriteLine(reader.LocalName);
				Console.WriteLine(reader.BaseURI);
				
				System.Collections.Generic.List<Amic.GridCreator.Pictogram> pic_list=new System.Collections.Generic.List<Amic.GridCreator.Pictogram>();
				
			//	System.Collections.Generic.KeyValuePair<string,string>image_pair=new System.Collections.Generic.KeyValuePair<string, string>();
				string theme="";
				
				
				
				Amic.GridCreator.Pictogram pictogram=null;
				while(reader.Read())
				{
					
					if (reader.Name=="cathegoryname")
						cat.name=reader.ReadElementString();
					
					if(reader.Name=="defaultColor")
						cat.default_color=reader.ReadElementString();
					
					
					if(reader.Name=="pictogram" && reader.IsStartElement() )
						pictogram=new Amic.GridCreator.Pictogram();
					
					if(reader.Name=="pictogram" && !reader.IsStartElement())
					{
						if(pictogram!=null)
							pic_list.Add(pictogram);
					}
					
					if(reader.Name=="background")
					{
						pictogram.background=reader.ReadElementString();
					}
					
					if(reader.Name=="pictname")
					{
						
						//Console.WriteLine();
						pictogram.pictname=reader.ReadElementString();	
					}
					

					
					if(reader.Name=="theme" && !reader.IsEmptyElement)
					{
						theme=reader.ReadElementString();	
					}
					
					if(reader.Name=="source" && !reader.IsEmptyElement)
					{
						//image_pair=new System.Collections.Generic.KeyValuePair<string, string>(theme,reader.ReadElementString());
						//pictogram.image_list.Add(image_pair);
						pictogram.image_list[theme]=reader.ReadElementString();
					}
					
					if(reader.Name=="caption")
					{
						
						pictogram.fontFace=reader.GetAttribute("fontface");
						pictogram.fontSize=Convert.ToInt16(reader.GetAttribute("size"));
						pictogram.fontTypeFace=reader.GetAttribute("typeface");
						pictogram.fontColor=reader.GetAttribute("color");
						pictogram.caption=reader.ReadElementString();
					}
					
					if(reader.Name=="speech")
						pictogram.actionSpeech=reader.ReadElementString();
					if(reader.Name=="sound")
						pictogram.actionSound=reader.ReadElementString();
					
					//				
					
				}
				
				foreach(Amic.GridCreator.Pictogram p in pic_list)
				{
					Console.WriteLine(p.pictname);
					foreach(System.Collections.Generic.KeyValuePair<string,string> key in p.image_list)
						Console.WriteLine("\t" + key.Key + " " + key.Value);
				}
				
				Console.WriteLine("END");
				
				cat.pic_list=pic_list;
				
				return cat;
				
			}
			
			
			
			public void loadFileAlt(string path)
			{
				try{
					System.Xml.XmlTextReader reader=new System.Xml.XmlTextReader(path);
					
					Console.WriteLine(reader.LocalName);
					Console.WriteLine(reader.BaseURI);
					Amic.GridCreator.Pictogram pictogram=null;
					Amic.GridCreator.Grid grid2=new Amic.GridCreator.Grid();
					while(reader.Read())
					{
						if (reader.Name=="gridname" && reader.IsStartElement())
							grid2.name=reader.ReadElementString();
						if (reader.Name=="class" && reader.IsStartElement())
							grid2.class_=reader.ReadElementString();
						if (reader.Name=="width" && reader.IsStartElement())
							grid2.width=reader.ReadElementContentAsInt();
						if (reader.Name=="height" && reader.IsStartElement())
							grid2.height=reader.ReadElementContentAsInt();
						//Amic.GridCreator.Pictogram pictogram=new Amic.GridCreator.Pictogram();
						if (reader.Name=="pictogram" && reader.IsStartElement())
						{
	
							if(pictogram!=null)
							{
								
								Console.WriteLine("> " + pictogram.row + " " + pictogram.col + " " + pictogram.pictname + " " + pictogram.background + " " + pictogram.image + " " + pictogram.fontSize);
								
								
							}
							
							pictogram=new Amic.GridCreator.Pictogram();
							pictogram.images=new System.Collections.Generic.Dictionary<string, string>();
						//	Console.WriteLine("ROW> " + reader.GetAttribute("row"));
							pictogram.row=Convert.ToInt32(reader.GetAttribute("row"));
							pictogram.col=Convert.ToInt32(reader.GetAttribute("col"));
							
							
						}
						
						if (reader.Name=="pictname" && reader.IsStartElement())
							pictogram.pictname=reader.ReadElementString();
						if (reader.Name=="background" && reader.IsStartElement())
							pictogram.background=reader.ReadElementString();
						
						
						/* OLD IMAGES FORMAT
						if (reader.Name=="image" && reader.IsStartElement())
							pictogram.image=reader.ReadElementString();
							
						*/
							
						
						if(reader.Name=="theme" && reader.IsStartElement())
							pictogram.theme=reader.ReadElementString();
						
						if(reader.Name=="source" && reader.IsStartElement())
						{
							pictogram.image=reader.ReadElementString();
							pictogram.image_list[pictogram.theme]=pictogram.image;
						}
						
						
						
						if (reader.Name=="caption" && reader.IsStartElement())
						{
							//Console.WriteLine("fontface " + reader.GetAttribute("fontface"));
							pictogram.fontFace=reader.GetAttribute("fontface");
							pictogram.fontTypeFace=reader.GetAttribute("typeface");
							pictogram.fontColor=reader.GetAttribute("color");
							pictogram.fontSize=Convert.ToInt32(reader.GetAttribute("size"));
							pictogram.align=reader.GetAttribute("align");
							pictogram.caption=reader.ReadElementString();
						}
						
						
						
						if(reader.Name=="sound" && reader.IsStartElement())
						{
							pictogram.actionSound=reader.ReadElementString();
							pictogram.actionType="sound";
						//	Console.WriteLine(pictogram.actionSound);
							grid2.pictogram_list.Add(pictogram);
						}
					
						if(reader.Name=="speech" && reader.IsStartElement())
						{
							pictogram.actionSpeech=reader.ReadElementString();
							pictogram.actionType="speech";
						//	Console.WriteLine(pictogram.actionSpeech);
							grid2.pictogram_list.Add(pictogram);	
						}
						if(reader.Name=="child" && reader.IsStartElement())
						{
							pictogram.actionChild=reader.ReadElementString();
							pictogram.actionType="child";
						//	Console.WriteLine(pictogram.actionSpeech);
							grid2.pictogram_list.Add(pictogram);
						}
						if(reader.Name=="parent" && reader.IsStartElement())
						{
							pictogram.actionType="parent";
							grid2.pictogram_list.Add(pictogram);
							
						}
							
						
						
					

						
					
					
					
					
						
					}
					
					Console.WriteLine("DIC " + grid2.pictogram_list.Count);
					foreach(Amic.GridCreator.Pictogram pic in grid2.pictogram_list)
					{
						foreach(System.Collections.Generic.KeyValuePair<string,string> key in pic.images)
							Console.WriteLine("{0} = {1}",key.Key,key.Value);
						//Console.WriteLine(pic.caption);
					}
					Amic.GridCreator.Core.getCore().openedGrid=grid2;
				
				} catch(Exception exc)	
				{
					Console.WriteLine("Load Exception: "+exc.Message);
					
				}
				
				
			}
			

		}
	}
	
}
	
